//TODO: Include C file IO header (stdio.h? Whatever it is)
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <regex>
#include "graph.hpp"      // struct adjmatrix
#include "read_input.hpp" // read_input

#define MAX_LINE_LEN 1024

// Vector of regices
std::vector<std::regex> patterns = {
   //* A line starting with a % is a comment, and should be skipped
   //* A blank line should be skipped
   //* A line starting with `num_processes=` contains the number of processes
   std::regex("^.*(num_processes)\\s*=\\s*(\\d+).*"),
   //* A line starting with `num_resources=` contains the number of resources
   std::regex("^.*(num_resources)\\s*=\\s*(\\d+)"),
   //* A line containing comma-separated values should be returned as-is, for manual disassembly
   std::regex("^([0-9, ]+)")
};

// TODO: Implement reading from a file
void read_file(std::string filename) {
   // Open file with name filename as read-only
   std::fstream f; f.open(filename, f.in);
   // TODO: Check for file IO errors (I might have a solution for that in another project)

   int num_processes = 0, num_resources = 0;
   std::vector<int> rescount;
   std::vector<std::vector<int>> matrix;
   std::string line; // Lines can be no more than 1KB in size, a sensible limitation
   while (!f.eof()) {
      std::getline (f, line);
      std::smatch res;
      // Iterate over each pattern, and grab the associated data
      for (auto pattern: patterns) {
         if (std::regex_search (line, res, pattern)) {
            // get the pattern type, value
            std::string type = res.format("$1"), value = res.format("$2");
            // Handle the pattern
            if (type == "num_processes") { num_processes = std::stoi(value); } else
            if (type == "num_resources") { num_resources = std::stoi(value); } else
            if (type.length()/2 <= num_resources) {
               // This is the resource count structure

            }
            break;
         }
      }
   }

   // Close file
   f.close();
   // TODO: Check for file IO errors (Shouldn't be any)
   return;
}
